#!/usr/bin/env python
#This code is public domain. Written by A. Bram Neijt <bneijt@gmail.com>
# Program usage: python theora_banner.py <banner_image.png>
import sys
import os
import PIL.Image
import subprocess

def main(args):
  #Parse arguments
  if len(args) < 2:
    print "Program usage: python theora_banner.py <banner_image.png>"
    return 1
  inputImageName = args[1]
  outputDir = 'theora_banner_sequence'
  if not os.path.exists(outputDir):
    os.mkdir(outputDir)
  
  #Take banner, split it up into moving parts
  img = PIL.Image.open(inputImageName)
  #Create output images by pasting banner into parts
  sequenceImage = img.copy()
  width = 100
  nFrames = 300
  speed = float(img.size[0])/float(nFrames)
  sequenceImage = sequenceImage.resize((width, sequenceImage.size[1]))
  for i in range(nFrames):
    
    sequenceImage.paste(img, (int(round(-i * speed)), 0))
    sequenceImage.paste(img, (int(round(-i * speed+ img.size[0])), 0))
    #TODO: Apply mask?
    sequenceImage.save("%s/frame%06i.png" % (outputDir, i))
  #Encode separate images into a moving banner, ffmpeg2the rescue
  #Exec ffmpeg2theora -f image2 frame%06d.png -o output.ogv  
  subprocess.check_call(['ffmpeg2theora', '-f', 'image2', '%s/frame%%06d.png' % outputDir, '-o', 'theora_banner.ogv'])
  return 0

if __name__ == "__main__":
  sys.exit(main(sys.argv))


